package com.sd.business.service.order.impl;

import cn.hutool.core.bean.BeanUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.sd.business.entity.order.dto.OrderSkuBomDto;
import com.sd.business.entity.order.dto.OrderSkuBomSelectDto;
import com.sd.business.entity.order.po.OrderOperatingLog;
import com.sd.business.entity.order.po.OrderSkuBom;
import com.sd.business.entity.order.vo.OrderSkuBomVo;
import com.sd.business.mapper.order.OrderSkuBomMapper;
import com.sd.business.service.order.OrderOperatingLogService;
import com.sd.business.service.order.OrderSkuBomService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;


/**
 * <p>
 * 订单sku bom 关联 服务实现类
 * </p>
 *
 * @author
 * @since 2023-07-10
 */
@Service
public class OrderSkuBomServiceImpl extends ServiceImpl<OrderSkuBomMapper, OrderSkuBom> implements OrderSkuBomService {

    @Autowired
    private OrderOperatingLogService orderOperatingLogService;

    @Override
    public Page<OrderSkuBomVo> getPage(OrderSkuBomSelectDto dto) {
        IWrapper<OrderSkuBom> wrapper = getWrapper();
        wrapper.orderByDesc("osb", OrderSkuBom::getId);
        Page<OrderSkuBomVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public OrderSkuBomVo detail(Long id) {
        OrderSkuBom OrderSkuBom = this.getById(id);
        OrderSkuBomVo result = BeanUtil.toBean(OrderSkuBom, OrderSkuBomVo.class);
        return result;
    }

    @Override
    public void add(OrderSkuBomDto orderSkuBomDto) {
        this.save(orderSkuBomDto);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(OrderSkuBomDto orderSkuBomDto) {
        this.updateById(orderSkuBomDto);
        OrderOperatingLog orderOperatingLog = new OrderOperatingLog();
        orderOperatingLog.setType(orderSkuBomDto.getUpdateType());
        orderOperatingLog.setOrderId(orderSkuBomDto.getOrderId());
        orderOperatingLog.setOrderCode(orderOperatingLog.getOrderCode());
        orderOperatingLogService.save(orderOperatingLog);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
